#ifndef RAM_CODE_H
#define RAM_CODE_H

#include <stdint.h>

/*
All possible values for bank switching are:
Value 0 is 2MB addressing the full momory space
Values 1 - 31 are for 64K segments where the value choses the respective segment
Values 0x80 - 0x83 are 512K segments, masking the low two bits chooses which of
   the segments will be used. So 0x80 is the one from offset 0, 0x81 is the one
   from offset 512K, etc.
The bank switching should be done typicaly in RAM since the effect of the switch
will be immediately applied, and the next address fetched is from the new bank!
*/
#define BANK_SWITCH (*((volatile uint8_t _far *)0x1FFFFF))

void switch_memory_bank(uint8_t bank);
void erase_sector(uint32_t address);
void write_byte(uint32_t address, uint8_t value);

#endif//RAM_CODE_H
